"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

exports.default = positionGroup;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function positionGroup(nodes, group) {
  var rect = {
    top: Number.MAX_VALUE,
    left: Number.MAX_VALUE,
    bottom: 0,
    right: 0
  };

  group.nodes.forEach(function (n) {
    var node = nodes.get(n);
    if (!node) return;
    if (node.x < rect.left) rect.left = node.x;
    if (node.x > rect.right) rect.right = node.x;
    if (node.y < rect.top) rect.top = node.y;
    if (node.y + node.dy > rect.bottom) rect.bottom = node.y + node.dy;
  });

  return (0, _assign2.default)({}, group, { rect: rect });
}