'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createGraph = createGraph;

var _graphlib = require('graphlib');

function createGraph(nodes, edges) {
  var G = new _graphlib.Graph({ directed: true });

  edges.forEach(function (edge) {
    G.setEdge(edge.source, edge.target, { data: edge });
  });

  G.nodes().forEach(function (u) {
    return G.setNode(u, { data: {} });
  });

  console.log('createGraph', nodes, edges);
  nodes.forEach(function (node) {
    G.node(node.id).data = node;
    // XXX should be configurable?
    console.log('node', node);
    if (node.reversed !== undefined) G.node(node.id).reversed = node.reversed;
  });

  return G;
}